VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WindowsControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' <GPL>
Option Explicit

' Author: Keith Hoerling
' Email:  keith@hoerling.com
' Http:   http://keith.lbox.org

' Redistribute under terms specified by the GNU public license.
' Please send any modifications or changes to the above address.
' Any feedback is warmly welcomed, thank you.

' Visit the above website for full CVS Web access to this source
' code and many other projects.


' Required for logoff, reboot and shutdown actionList
Private Declare Function ExitWindowsEx& Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long)

Private Const EWX_FORCE = 4
Private Const EWX_LOGOFF = 0
Private Const EWX_REBOOT = 2
Private Const EWX_POWEROFF = 8
Private Const EWX_SHUTDOWN = 1

' Required for operating system versioning
Private Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
End Type
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Const VER_PLATFORM_WIN32_NT = 2
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32s = 0

' Required to adjust privileges under NT
Private Const ANYSIZE_ARRAY = 1
Private Type LUID
        lowpart As Long
        highpart As Long
End Type

Private Type LUID_AND_ATTRIBUTES
        pLuid As LUID
        Attributes As Long
End Type
Private Type LARGE_INTEGER
        lowpart As Long
        highpart As Long
End Type

Private Declare Function GetCurrentProcess Lib "kernel32" () As Long
Private Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal processHandle As Long, ByVal DesiredAccess As Long, tokenHandle As Long) As Long
Private Declare Function AdjustTokenPrivileges Lib "advapi32.dll" (ByVal tokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Private Declare Function LookupPrivilegeValue Lib "advapi32.dll" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Private Type TOKEN_PRIVILEGES
        PrivilegeCount As Long
        Privileges(ANYSIZE_ARRAY) As LUID_AND_ATTRIBUTES
End Type

Private Const TOKEN_QUERY = (&H8)
Private Const TOKEN_ADJUST_PRIVILEGES = (&H20)
Private Const SE_SHUTDOWN_NAME = "SeShutdownPrivilege"
Private Const SE_PRIVILEGE_ENABLED = &H2

Private Function getPlatformID() As Long
        Dim myVersionInformation As OSVERSIONINFO
    
        myVersionInformation.dwOSVersionInfoSize = Len(myVersionInformation)
        Call GetVersionEx(myVersionInformation)
        getPlatformID = myVersionInformation.dwPlatformId
End Function

Public Function adjustUserPrivileges() As Boolean ' NT, 2000, XP, ...
        Dim myLUID As LUID
        Dim myProcessHandle As Long
        Dim myTokenHandle As Long
        Dim myTokenPrivileges As TOKEN_PRIVILEGES
        Dim myDummyPrivileges As TOKEN_PRIVILEGES
    
        ' check for platform id
        If (getPlatformID >= VER_PLATFORM_WIN32_NT) Then
                If (LookupPrivilegeValue(vbNullString, SE_SHUTDOWN_NAME, myLUID)) Then
                        myProcessHandle = GetCurrentProcess()
                                If (myProcessHandle) Then
                                        If (OpenProcessToken(myProcessHandle, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, myTokenHandle)) Then
                                                ' set data structures for necessary privilages
                                                With myTokenPrivileges
                                                        .PrivilegeCount = 1
                                                                With .Privileges(0)
                                                                        .Attributes = SE_PRIVILEGE_ENABLED
                                                                        .pLuid.highpart = myLUID.highpart
                                                                        .pLuid.lowpart = myLUID.lowpart
                                                                End With
                                                End With
                
                                        ' adjust privileges
                                        If (AdjustTokenPrivileges(myTokenHandle, 0, myTokenPrivileges, Len(myTokenPrivileges), myDummyPrivileges, 0) = 0) Then
                                                adjustUserPrivileges = False
                                        End If
                                        Call CloseHandle(myTokenHandle) ' clean up
                                End If
                        End If
                End If
        End If
        adjustUserPrivileges = True
End Function

Public Function systemCanPowerOff() As Boolean
        systemCanPowerOff = getPlatformID > 1
End Function

Public Sub performAction(anAction As String, useForce As Boolean)
        Dim myAction As Variant
'adsf
        ' set appropriate action
        Select Case anAction
                Case "Reboot": myAction = EWX_REBOOT
                Case "Logoff": myAction = EWX_LOGOFF
                Case "Poweroff": myAction = EWX_POWEROFF
                Case "Shutdown": myAction = EWX_SHUTDOWN
        End Select
        
        ' use force?
        If (useForce = True) Then myAction = myAction + EWX_FORCE
        
        ' execute
        Call ExitWindowsEx(myAction, 0)
End Sub

' convienence methods
Public Sub performLogoff(useForce As Boolean)
        Call performAction("Logoff", useForce)
End Sub

Public Sub performPoweroff(useForce As Boolean)
        Call performAction("Poweroff", useForce)
End Sub

Public Sub performReboot(useForce As Boolean)
        Call performAction("Reboot", useForce)
End Sub

Public Sub performShutdown(useForce As Boolean)
        Call performAction("Shutdown", useForce)
End Sub

